package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.block.BlockBreakEvent
import org.bukkit.event.block.BlockPlaceEvent

class BuildRestrictionListener(
    private val arenaManager: ArenaManager,
): Listener {

    @EventHandler
    fun onBlockPlace(event: BlockPlaceEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.RESTRICT_BUILDING, event.player))
            return

        if (!arenaManager.currentArena!!.config.placeAllowed.isAllowed(event.blockPlaced.type)) {
            event.isCancelled = true;
        }
    }

    @EventHandler
    fun onBlockBreak(event: BlockBreakEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.RESTRICT_BUILDING, event.player))
            return

        if (!arenaManager.currentArena!!.config.breakAllowed.isAllowed(event.block.type)) {
            event.isCancelled = true;
        }
    }
}