package nl.kallestruik.darena.listeners

import net.kyori.adventure.text.Component
import nl.kallestruik.darena.events.CheckpointReachedEvent
import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import nl.kallestruik.darena.util.ArenaUtil
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener

class CheckpointMessageListener(
    val arenaManager: ArenaManager
): Listener {

    @EventHandler
    fun onCheckpointReached(event: CheckpointReachedEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.CHECKPOINT_MESSAGE, event.player)) {
            return
        }

        val timeSinceStart = System.currentTimeMillis() - event.arena.session!!.startTime

        //TODO: Make this message configurable.
        event.arena.sendMessage(Component.text("${event.player.name} has reached a checkpoint! [${ArenaUtil.formatTimeMillis(timeSinceStart)}]"))
    }
}