package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerFishEvent

class GrapplingHookListener(
    val arenaManager: ArenaManager,
): Listener {

    @EventHandler
    fun onFish(event: PlayerFishEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.ITEM_GRAPPLING_HOOK, event.player)) {
            return
        }

        if (!isNearBlock(event.hook.location))
            return

        val direction = event.hook.location.toVector().subtract(event.player.eyeLocation.toVector()).normalize()

        event.player.velocity = event.player.velocity.add(direction.multiply(3))
    }

    fun isNearBlock(location: Location): Boolean {
        if (location.subtract(0.0, 1.0, 0.0).block.type != Material.AIR)
            return true

        if (location.subtract(1.0, 0.0, 0.0).block.type != Material.AIR)
            return true

        if (location.subtract(0.0, 0.0, 1.0).block.type != Material.AIR)
            return true

        if (location.add(0.0, 1.0, 0.0).block.type != Material.AIR)
            return true

        if (location.add(1.0, 0.0, 0.0).block.type != Material.AIR)
            return true

        if (location.add(0.0, 0.0, 1.0).block.type != Material.AIR)
            return true

        return false
    }
}