package nl.kallestruik.darena.types

import net.kyori.adventure.text.Component
import net.kyori.adventure.text.format.TextColor
import org.bukkit.Bukkit
import org.bukkit.configuration.ConfigurationSection

data class Team(
    val name: String
) {
    val mcTeam: org.bukkit.scoreboard.Team = Bukkit.getScoreboardManager().mainScoreboard.getTeam(name)
        ?: Bukkit.getScoreboardManager().mainScoreboard.registerNewTeam(name)

    init {
        mcTeam.setOption(org.bukkit.scoreboard.Team.Option.COLLISION_RULE, org.bukkit.scoreboard.Team.OptionStatus.NEVER)
    }

    var color: TextColor = TextColor.color(0xFFFFFF)
        set(value) {
            field = value
            mcTeam.prefix(mcTeam.prefix().color(value))
        }
    var prefix: String = ""
        set(value) {
            field = value
            mcTeam.prefix(Component.text("$value ").color(color))
        }

    fun save(section: ConfigurationSection) {
        val teamSection = section.createSection(name)
        teamSection.set("color", color.asHexString())
        teamSection.set("prefix", prefix)
    }

    companion object {
        fun fromConfig(section: ConfigurationSection): Team {
            val team = Team(
                section.name
            )
            team.color = TextColor.fromCSSHexString(section.getString("color")!!)!!
            team.prefix = section.getString("prefix")!!

            return team
        }
    }

}