package nl.kallestruik.darena.types.arena

import kotlinx.serialization.Serializable
import nl.kallestruik.darena.arenas.world.ArenaWorld
import nl.kallestruik.dlib.config.annotations.Description
import org.bukkit.Material

@Serializable
data class ArenaBlockRemoveZone(
    @Description(["The lower corner of the area to remove."])
    val lower: ArenaLocation,
    @Description(["The upper corner of the area to remove."])
    val upper: ArenaLocation,
) {
    fun removeBlocks(world: ArenaWorld) {
        for (x in lower.x.until(upper.x + 1)) {
            for (y in lower.y.until(upper.y + 1)) {
                for (z in lower.z.until(upper.z + 1)) {
                    world.world.getBlockAt(x, y, z).type = Material.AIR
                }
            }
        }
    }
}
