package nl.kallestruik.darena.types.arena

import kotlinx.serialization.Serializable
import nl.kallestruik.darena.types.border.AbstractBorderNode
import nl.kallestruik.dlib.config.annotations.Description

@Serializable
data class ArenaBorders(
    @Description(["The vertical border of the world. This is the normal minecraft border."])
    val vertical: List<AbstractBorderNode> = listOf(),
    @Description(["A horizontal border that kills everyone that is above it. This border is indicated using particle effects."])
    val top: List<AbstractBorderNode> = listOf(),
    @Description(["A horizontal border that kills everyone that is below it. This border is indicated using particle effects."])
    val bottom: List<AbstractBorderNode> = listOf(),
)