package nl.kallestruik.darena.types.arena

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.DefaultBoolean
import nl.kallestruik.dlib.config.annotations.Description

@Serializable
data class ArenaCheckpoint(
    @Description(["The name of the checkpoint."])
    val label: String,
    @Description(["The lower corner of the checkpoint area."])
    val lower: ArenaLocation,
    @Description(["The upper corner of the checkpoint area."])
    val upper: ArenaLocation,
    @SerialName("spawn-rule")
    @Description(["The spawn rule to use for this checkpoint when respawning or moving players."])
    var spawnRule: String = "",
    @SerialName("spawn-pool")
    @Description(["The spawn pool to use for this checkpoint when respawning or moving players."])
    val spawnPool: String = "",
    @SerialName("move-player")
    @Description(["Whether or not to teleport players to the spawn-rule/spawn-pool when they reach the checkpoint."])
    @DefaultBoolean(false)
    val movePlayer: Boolean = false,
    @SerialName("is-finish")
    @Description(["Whether or not this checkpoint counts as a finish. If it does players will be placed into spectator mode upon reaching it."])
    @DefaultBoolean(false)
    val isFinish: Boolean = false,
)
