package nl.kallestruik.darena.types.arena

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.DefaultInt
import nl.kallestruik.dlib.config.annotations.Description
import nl.kallestruik.dlib.config.annotations.MinInt

@Serializable
data class ArenaCountdown(
    @SerialName("loading")
    @Description(["The time to count down before teleport players into the map for spectating."])
    @MinInt(0)
    @DefaultInt(10)
    var loadingTime: Int = 10,
    @SerialName("spectator")
    @Description(["The time players have in spectator mode before being moved to the staging area."])
    @MinInt(0)
    @DefaultInt(10)
    var spectatorTime: Int = 10,
    @SerialName("before-start")
    @Description(["The time to count down in the staging area before removing the area defined in the block-remove-zone section."])
    @MinInt(0)
    @DefaultInt(10)
    var beforeStartTime: Int = 10,
)
