package nl.kallestruik.darena.types.arena

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.DefaultInt
import nl.kallestruik.dlib.config.annotations.Description
import nl.kallestruik.dlib.config.annotations.MinInt

@Serializable
data class ArenaEndConditions(
    @SerialName("players-left")
    @Description(["End the game when there are this many players left alive. Set to -1 to disable."])
    @MinInt(-1)
    @DefaultInt(-1)
    val playersLeft: Int = -1,
    @Description(["End the game after this amount of seconds. Set to -1 to disable."])
    @MinInt(-1)
    @DefaultInt(-1)
    val time: Int = -1,
    @SerialName("players-finished")
    @Description(["End the game after this amount of players reach a finish checkpoint. Set to -1 to disable."])
    @MinInt(-1)
    @DefaultInt(-1)
    val playersFinished: Int = -1,
)
