package nl.kallestruik.darena.types.arena

import org.bukkit.Location

data class ProcessedArenaCheckpoint(
    val label: String,
    val lower: ArenaLocation,
    val upper: ArenaLocation,
    var spawnRule: ProcessedArenaSpawnRule?,
    val spawnPool: ProcessedArenaSpawnPool?,
    val movePlayer: Boolean,
    val isFinish: Boolean,
) {
    constructor(checkpoint: ArenaCheckpoint, spawnRule: ProcessedArenaSpawnRule?, spawnPool: ProcessedArenaSpawnPool?)
        : this(checkpoint.label, checkpoint.lower, checkpoint.upper, spawnRule, spawnPool, checkpoint.movePlayer, checkpoint.isFinish)

    fun isInside(location: Location): Boolean {
        return location.blockX <= upper.x && location.blockX >= lower.x
                && location.blockY <= upper.y && location.blockY >= lower.y
                && location.blockZ <= upper.z && location.blockZ >= lower.z
    }

    fun resolveSpawnRule() {
        if (spawnRule != null)
            return

        spawnRule = spawnPool!!.nextRule()
    }
}
