package nl.kallestruik.darena.types.border

import org.bukkit.plugin.java.JavaPlugin

class BorderNodeTransition(
    private val size: Double,
    private val time: Long
): AbstractBorderNode() {

    override fun execute(border: AbstractBorder, plugin: JavaPlugin) {
        border.size(size, time)
        runNext(border, plugin)
    }

    override fun toCommand(): String {
        return "TRANSITION $size $time"
    }

    companion object {
        fun fromParameters(params: String): BorderNodeTransition {
            val parts = params.split(" ")
            return BorderNodeTransition(parts[0].toDouble(), parts[1].toLong())
        }
    }
}