package nl.kallestruik.darena.types.border

import org.bukkit.plugin.java.JavaPlugin
import org.bukkit.scheduler.BukkitRunnable

class BorderNodeWait(
    private val time: Long
): AbstractBorderNode() {
    private var runnable: BukkitRunnable? = null

    override fun execute(border: AbstractBorder, plugin: JavaPlugin) {
        object : BukkitRunnable() {
            override fun run() {
                runNext(border, plugin)
            }
        }.runTaskLater(plugin, time * 20)
    }

    override fun toCommand(): String {
        return "WAIT $time"
    }

    override fun cancel() {
        super.cancel()
        runnable?.cancel()
    }

    companion object {
        fun fromParameters(params: String): BorderNodeWait {
            return BorderNodeWait(params.toLong())
        }
    }
}